"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const three_1 = require("three");
function Focusable(Base) {
    class FocusableMixIn extends Base {
        defaults() {
            return Object.assign(Object.assign({}, super.defaults()), { isFocusable: true, isFocused: false, focusMaterial: new three_1.MeshLambertMaterial({
                    transparent: true,
                    opacity: 0.8,
                    userData: { importance: 1 },
                }) });
        }
        init() {
            super.init();
            this.focusMaterial.color = this.material.color;
        }
        focus() {
            if (this.isFocused)
                return;
            this.isFocused = true;
            this.setMaterial(this.focusMaterial);
            this.onChangeFocus(true);
        }
        blur() {
            if (!this.isFocused)
                return;
            this.isFocused = false;
            this.removeMaterial(this.focusMaterial);
            this.onChangeFocus(false);
        }
        onChangeFocus(v) { }
    }
    return FocusableMixIn;
}
exports.default = Focusable;
//# sourceMappingURL=Focusable.js.map