import ConstructorOf from '@thats/utils/types/ConstructorOf';
import { Vector2 } from 'three';
import XRController, { XRControllerConstructor } from '../../core/XRController';
import { ISelector } from '../selector/Selector';
import { IGrabbable } from './Grabbable';
export interface IGrabber extends XRController {
    grabbed: IGrabbable[];
    drag(v: Vector2): void;
    grab(v: IGrabbable): void;
    ungrab(v: IGrabbable): void;
    ungrabAll(): void;
    onChangeGrabbed(v: IGrabbable[]): void;
}
export default function Grabber(): ((<T extends XRController>(Base: XRControllerConstructor<T>) => ConstructorOf<T & import("../focuser/Focuser").IFocuser>) | (<T_1 extends import("../focuser/Focuser").IFocuser>(Base: XRControllerConstructor<T_1>) => ConstructorOf<T_1 & ISelector>) | typeof GrabberMixin)[];
declare function GrabberMixin<T extends ISelector>(Base: XRControllerConstructor<T>): ConstructorOf<T & IGrabber>;
export {};
