"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const three_1 = require("three");
const GrabActionType_1 = __importDefault(require("../../enums/GrabActionType"));
const Grabber_1 = __importDefault(require("../grabber/Grabber"));
function Rotator() {
    return [...(0, Grabber_1.default)(), RotatorMixIn];
}
exports.default = Rotator;
function RotatorMixIn(Base) {
    class RotatorMixInClass extends Base {
        drag(v) {
            super.drag(v);
            if (this.project.state.grabAction !== GrabActionType_1.default.ROTATE)
                return;
            if (!v.length())
                return;
            const rotationSpeed = 1.2;
            this.grabbed.forEach(m => {
                m.rotateOnWorldAxis(new three_1.Vector3(0, 1, 0), -v.x * rotationSpeed);
                m.rotateOnWorldAxis(new three_1.Vector3(1, 0, 0), -v.y * rotationSpeed);
                m.needsUpdate = true;
            });
        }
    }
    return RotatorMixInClass;
}
//# sourceMappingURL=Rotator.js.map