"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const three_1 = require("three");
function SelectorKeyboard(Base) {
    class SelectorKeyboardMixIn extends Base {
        constructor() {
            super(...arguments);
            this._justHit = false;
        }
        defaults() {
            return Object.assign(Object.assign({}, super.defaults()), { selectRaycaster: new three_1.Raycaster(), selectMousePos: new three_1.Vector2() });
        }
        onMouseDown(e) {
            super['onMouseDown'](e);
            const viewer = this.project.viewer;
            const plyr = this.project.player;
            if (!viewer)
                return;
            const { w: width, h: height } = viewer.dims;
            const offset = this.mouseDownPos.offset;
            this.selectMousePos.x = (offset.x / width) * 2 - 1;
            this.selectMousePos.y = 0 - ((offset.y / height) * 2 - 1);
            this.selectRaycaster.setFromCamera(this.selectMousePos, plyr.camera);
            const targets = this.selectorTargets.map(m => m);
            const intersects = this.selectRaycaster.intersectObjects(targets);
            const hitTargetIdx = intersects.length > 0 ? targets.indexOf(intersects[0].object) : -1;
            this._justHit = hitTargetIdx >= 0;
            if (this._justHit) {
                this.select(this.selectorTargets[hitTargetIdx]);
            }
        }
        onMouseUp(e) {
            super['onMouseUp'](e);
            this.deselectAll();
        }
    }
    return SelectorKeyboardMixIn;
}
exports.default = SelectorKeyboard;
//# sourceMappingURL=SelectorKeyboard.js.map