import { Material, Mesh, Vector3 } from 'three';
import { XRUpdateParams } from './XRClass';
declare const XRMass_base: import("@thats/utils/types/ConstructorOf").ConstructorOf<import("./XRClass").IClass & Mesh<any, any>>;
export default class XRMass extends XRMass_base {
    body: Ammo.btRigidBody;
    needsUpdate: boolean;
    mass: number;
    materialStack: Material[];
    defaults(): any;
    init(): void;
    initGeometry(): void;
    update(p?: XRUpdateParams): void;
    setAngularVelocity(x?: number | Vector3, y?: number, z?: number): void;
    setLinearVelocity(x?: number | Vector3, y?: number, z?: number): void;
    setMaterial(m: Material): void;
    removeMaterial(m: Material | Material[], importance?: number): void;
    turnOnTempKinematics(): void;
    turnOffTempKinematics(): void;
    stopVelocities(): void;
    private _applyThreeToAmmo;
    private _applyAmmoToThree;
}
export {};
