"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const three_1 = require("three");
const XRMass_1 = __importDefault(require("../core/XRMass"));
class Torus extends XRMass_1.default {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { radius: 1, tube: 0.4, radialSegments: 8, tubularSegments: 6, arc: Math.PI * 2 });
    }
    initGeometry() {
        this.geometry = new three_1.TorusBufferGeometry(this.radius, this.tube, this.radialSegments, this.tubularSegments, this.arc);
    }
    growBy(v) {
        this.radius *= v;
        this.tube *= v;
        this.arc *= v;
        this.initGeometry();
    }
}
exports.default = Torus;
//# sourceMappingURL=Torus.js.map