"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.computeBounds = void 0;
const three_1 = require("three");
const iterateVertices_1 = __importDefault(require("./iterateVertices"));
const computeBounds = function (vertices, matrices) {
    const bounds = new three_1.Box3();
    let minX = +Infinity;
    let minY = +Infinity;
    let minZ = +Infinity;
    let maxX = -Infinity;
    let maxY = -Infinity;
    let maxZ = -Infinity;
    bounds.min.set(0, 0, 0);
    bounds.max.set(0, 0, 0);
    (0, iterateVertices_1.default)(vertices, matrices, v => {
        if (v.x < minX)
            minX = v.x;
        if (v.y < minY)
            minY = v.y;
        if (v.z < minZ)
            minZ = v.z;
        if (v.x > maxX)
            maxX = v.x;
        if (v.y > maxY)
            maxY = v.y;
        if (v.z > maxZ)
            maxZ = v.z;
    });
    bounds.min.set(minX, minY, minZ);
    bounds.max.set(maxX, maxY, maxZ);
    return bounds;
};
exports.computeBounds = computeBounds;
exports.default = exports.computeBounds;
//# sourceMappingURL=computeBounds.js.map