"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.computeRadius = void 0;
const three_1 = require("three");
const iterateVertices_1 = __importDefault(require("./iterateVertices"));
exports.computeRadius = (function () {
    const center = new three_1.Vector3();
    return function (vertices, matrices, bounds) {
        let maxRadiusSq = 0;
        let { x: cx, y: cy, z: cz } = bounds.getCenter(center);
        (0, iterateVertices_1.default)(vertices, matrices, v => {
            const dx = cx - v.x;
            const dy = cy - v.y;
            const dz = cz - v.z;
            maxRadiusSq = Math.max(maxRadiusSq, dx * dx + dy * dy + dz * dz);
        });
        return Math.sqrt(maxRadiusSq);
    };
})();
exports.default = exports.computeRadius;
//# sourceMappingURL=computeRadius.js.map