"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.iterateGeometries = void 0;
const three_1 = require("three");
exports.iterateGeometries = (function () {
    const inverse = new three_1.Matrix4();
    return function (root, options, cb) {
        if (parseInt(three_1.REVISION) >= 123)
            inverse.copy(root.matrixWorld).invert();
        else
            inverse.getInverse(root.matrixWorld);
        const scale = new three_1.Vector3();
        scale.setFromMatrixScale(root.matrixWorld);
        root.traverse(mesh => {
            const transform = new three_1.Matrix4();
            if (mesh.isMesh &&
                (options.includeInvisible || (mesh.el && mesh.el.object3D.visible) || mesh.visible)) {
                if (mesh === root) {
                    transform.identity();
                }
                else {
                    mesh.updateWorldMatrix(true);
                    transform.multiplyMatrices(inverse, mesh.matrixWorld);
                }
                cb(mesh.geometry.isBufferGeometry
                    ? mesh.geometry.attributes.position.array
                    : mesh.geometry.vertices, transform.elements, mesh.geometry.index ? mesh.geometry.index.array : null);
            }
        });
    };
})();
exports.default = exports.iterateGeometries;
//# sourceMappingURL=iterateGeometries.js.map