"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.XRProjectControls = void 0;
const useCallforward_1 = __importDefault(require("@thatreact/core-hooks/hooks/useCallforward"));
const Button_1 = __importDefault(require("@thatweb/core-mui/components/Button"));
const Col_1 = __importDefault(require("@thatweb/core-mui/components/Col"));
const SXDiv_1 = __importDefault(require("@thatweb/core-mui/components/sx/SXDiv"));
const react_1 = __importDefault(require("react"));
const GrabActionType_1 = __importDefault(require("../enums/GrabActionType"));
const PlayState_1 = __importDefault(require("../enums/PlayState"));
const ParamBox_1 = __importDefault(require("./paramboxes/ParamBox"));
const useXRSupported_1 = require("./useXRSupported");
const XRProjectViewerState_1 = require("./XRProjectViewerState");
function XRProjectControls() {
    var _a;
    const { project, setParam, setGrabAction, setGodMode, startXR, pause, play, stop } = (0, XRProjectViewerState_1.useXRProjectViewer)();
    const xrSupported = (0, useXRSupported_1.useXRSupported)();
    const handleChangeGrabAction = (0, useCallforward_1.default)((v) => () => setGrabAction(v), [setGrabAction]);
    const handleFullscreen = react_1.default.useCallback(() => alert('to be implemented'), []);
    const handleChangeParam = (0, useCallforward_1.default)(param => v => setParam(param, v), [setParam]);
    const params = Object.values(((_a = project === null || project === void 0 ? void 0 : project.scene) === null || _a === void 0 ? void 0 : _a.params) || {});
    return (react_1.default.createElement(SXDiv_1.default, { sx: { minWidth: 240 } },
        react_1.default.createElement(Col_1.default, { margin: "auto", spacing: 2, alignItems: "center", sx: { maxHeight: '100%' } },
            react_1.default.createElement(Button_1.default, { variant: "contained", color: "primary", disabled: !xrSupported, onClick: startXR, children: xrSupported ? 'Enter VR' : 'VR not Available' }),
            react_1.default.createElement(Button_1.default, { variant: "contained", color: "primary", disabled: project.state.play === PlayState_1.default.PLAYING, onClick: play, children: "Play" }),
            react_1.default.createElement(Button_1.default, { variant: "contained", color: "primary", disabled: project.state.play !== PlayState_1.default.PLAYING, onClick: pause, children: "Pause" }),
            react_1.default.createElement(Button_1.default, { variant: "contained", color: "primary", disabled: project.state.play === PlayState_1.default.STOPPED, onClick: stop, children: "Stop" }),
            react_1.default.createElement(Button_1.default, { variant: "contained", color: "secondary", disabled: project.state.grabAction === GrabActionType_1.default.MOVE, onClick: handleChangeGrabAction(GrabActionType_1.default.MOVE), children: "Move" }),
            react_1.default.createElement(Button_1.default, { variant: "contained", color: "secondary", disabled: project.state.grabAction === GrabActionType_1.default.ROTATE, onClick: handleChangeGrabAction(GrabActionType_1.default.ROTATE), children: "Rotate" }),
            react_1.default.createElement(Button_1.default, { variant: "contained", color: "secondary", disabled: project.state.grabAction === GrabActionType_1.default.RESIZE, onClick: handleChangeGrabAction(GrabActionType_1.default.RESIZE), children: "Resize" }),
            react_1.default.createElement(Col_1.default, { spacing: 2, p: 2, sx: { flex: 1, overflow: 'scroll', maxHeight: 300, width: '100%' } }, params.map((param, idx) => (react_1.default.createElement(ParamBox_1.default, { key: param.label + idx, param: param, onChange: handleChangeParam(param) })))))));
}
exports.XRProjectControls = XRProjectControls;
exports.default = XRProjectControls;
//# sourceMappingURL=XRProjectControls.js.map