"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useXRProjectViewer = exports.XRProjectViewerState = void 0;
const react_1 = __importStar(require("react"));
const XRProject_1 = __importDefault(require("../core/XRProject"));
const PlayState_1 = __importDefault(require("../enums/PlayState"));
const index_1 = __importDefault(require("../scenes/index"));
function XRProjectViewerState({ children, sceneIdx }) {
    const [changed, setChanged] = (0, react_1.useState)(new Date());
    const project = (0, react_1.useRef)(new XRProject_1.default());
    (0, react_1.useEffect)(() => () => project.current.destroy(), []);
    (0, react_1.useEffect)(() => {
        project.current.setScene(index_1.default[sceneIdx]);
        setChanged(new Date());
    }, [sceneIdx]);
    const initViewer = (0, react_1.useMemo)(() => (el, dims) => {
        project.current.initViewer(el, dims);
        setChanged(new Date());
    }, []);
    const setGrabAction = (0, react_1.useMemo)(() => (v) => {
        project.current.setGrabActionState(v);
        setChanged(new Date());
    }, []);
    const setGodMode = (0, react_1.useMemo)(() => (v) => {
        project.current.setGodModeState(v);
        setChanged(new Date());
    }, []);
    const setParam = (0, react_1.useMemo)(() => (param, value) => {
        project.current.setParam(param, value);
        setChanged(new Date());
    }, []);
    const stopXR = (0, react_1.useMemo)(() => () => {
        project.current.endXR();
        setChanged(new Date());
    }, []);
    const startXR = (0, react_1.useMemo)(() => () => {
        project.current.startXR();
        setChanged(new Date());
    }, []);
    const play = (0, react_1.useMemo)(() => () => {
        if (project.current.state.play === PlayState_1.default.PAUSED)
            project.current.play();
        else
            project.current.start();
        setChanged(new Date());
    }, []);
    const pause = (0, react_1.useMemo)(() => () => {
        project.current.pause();
        setChanged(new Date());
    }, []);
    const stop = (0, react_1.useMemo)(() => () => {
        project.current.stop();
        setChanged(new Date());
    }, []);
    const ctx = (0, react_1.useMemo)(() => ({
        project: project.current,
        setParam,
        setGodMode,
        setGrabAction,
        initViewer,
        play,
        pause,
        stop,
        startXR,
        stopXR,
    }), [changed]);
    return (react_1.default.createElement(XRProjectViewerStateContext.Provider, { value: ctx }, children));
}
exports.XRProjectViewerState = XRProjectViewerState;
exports.default = XRProjectViewerState;
const XRProjectViewerStateContext = react_1.default.createContext(null);
const useXRProjectViewer = () => (0, react_1.useContext)(XRProjectViewerStateContext);
exports.useXRProjectViewer = useXRProjectViewer;
//# sourceMappingURL=XRProjectViewerState.js.map